#include <iostream>
#include<vector>
#include<algorithm>
using namespace std;
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt;
    tt=1;
    while(tt--)
    {
        int t;
        cin>>t;
        int n,k;
        cin>>n>>k;
        vector<int>a(n);
        for(int i=0;i<n;i++)
            cin>>a[i];
        sort(a.begin(),a.end());
        int trval=0;
        for(int i=0;i<n;i++)
        {
            if(a[i]>=trval)trval++;
            else trval--;
        }
        int maxval=trval;
        reverse(a.begin(),a.end());
        trval=0;
        for(int i=0;i<n;i++)
        {
            if(a[i]>=trval)trval++;
            else trval--;
        }
        int minval=trval;
        if((k+minval)%2==0&&k<=maxval&&k>=minval)
            cout<<"DA"<<endl;
        else
            cout<<"NE"<<endl;
    }

}